package xyz.stachel.zombiesutils.game.recorder;

import org.jetbrains.annotations.NotNull;
import xyz.stachel.zombiesutils.ZombiesUtils;
import xyz.stachel.zombiesutils.game.GameMode;
import xyz.stachel.zombiesutils.game.recorder.files.CategoryFile;
import xyz.stachel.zombiesutils.util.Utils;

import java.io.File;

import static xyz.stachel.zombiesutils.game.GameMode.Map.*;

public class Category {
    private static String selectedCategory /*= ZombiesUtils.getInstance().getConfig().getDefaultCategory()*/;
    public final CategoryFile[] categoryFiles = new CategoryFile[10];
    private final String name;

    public Category() {
        final File category;
        if (Utils.isHypixel()) category = new File(new File("zombies", "splits"), selectedCategory);
        else category = new File(new File("zombies", "practise-splits"), selectedCategory);
        categoryFiles[0] = new CategoryFile(category, DEAD_END, GameMode.Difficulty.NORMAL);
        categoryFiles[1] = new CategoryFile(category, DEAD_END, GameMode.Difficulty.HARD);
        categoryFiles[2] = new CategoryFile(category, DEAD_END, GameMode.Difficulty.RIP);

        categoryFiles[3] = new CategoryFile(category, BAD_BLOOD, GameMode.Difficulty.NORMAL);
        categoryFiles[4] = new CategoryFile(category, BAD_BLOOD, GameMode.Difficulty.HARD);
        categoryFiles[5] = new CategoryFile(category, BAD_BLOOD, GameMode.Difficulty.RIP);

        categoryFiles[6] = new CategoryFile(category, ALIEN_ARCADIUM, GameMode.Difficulty.NORMAL);

        categoryFiles[7] = new CategoryFile(category, PRISON, GameMode.Difficulty.NORMAL);
        categoryFiles[8] = new CategoryFile(category, PRISON, GameMode.Difficulty.HARD);
        categoryFiles[9] = new CategoryFile(category, PRISON, GameMode.Difficulty.RIP);

        this.name = Category.selectedCategory;
    }

    public static void setSelectedCategory(String selectedCategory) {
        Category.selectedCategory = selectedCategory;
      //  ZombiesUtils.getGameManager().getGame().ifPresent(game -> game.setCategory(new Category()));
    }

    public static String[] getCategories() {
        File dir;
        if (Utils.isHypixel()) dir = new File("zombies" + File.separator + "splits");
        else dir = new File("zombies" + File.separator + "practise-splits");
        if (dir.isDirectory()) return dir.list();
        else return new String[0];
    }

    public CategoryFile getByGameMode(@NotNull GameMode gameMode) {
        return switch (gameMode.getMap()) {
            case DEAD_END -> switch (gameMode.getDifficulty()) {
                case NORMAL -> categoryFiles[0];
                case HARD -> categoryFiles[1];
                case RIP -> categoryFiles[2];
            };
            case BAD_BLOOD -> switch (gameMode.getDifficulty()) {
                case NORMAL -> categoryFiles[3];
                case HARD -> categoryFiles[4];
                case RIP -> categoryFiles[5];
            };
            case ALIEN_ARCADIUM -> categoryFiles[6];
            case PRISON -> switch (gameMode.getDifficulty()) {
                case NORMAL -> categoryFiles[7];
                case HARD -> categoryFiles[8];
                case RIP -> categoryFiles[9];
            };
        };
    }

    public String getName() {
        return name;
    }
}