package xyz.stachel.zombiesutils.game.recorder;

import org.jetbrains.annotations.Contract;

public class RecordMessageSender {

    private final StringBuilder recordMessage;
    private final int newTime;
    private final int oldTime;
    private final int round;
    private final String deltaString;
    private final String timeString;
    private String copyString;

    public RecordMessageSender(final String categoryName, final int round, final int newTime, final int oldTime) {
        this.recordMessage = new StringBuilder(
                "§l§a▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬\n§e Category: §d" + categoryName
        );
        this.newTime = newTime;
        this.oldTime = oldTime;
        this.deltaString = oldTime != 0 ? " " + formattedDelta(newTime, oldTime) : "";
        this.timeString = formattedTime(newTime);
        this.round = round;
    }

    public void sendRecordMessage() {
    }

    public void gameSplit() {
    }

    public void roundSplit() {
    }

    public void helicopterSplit() {
    }

    @Contract(pure = true)
    private String formattedTime(int time) {
        time *= 50;
        return String.format("%d:%02d.%d%d",
                time / 60000,
                (time % 60000) / 1000,
                (time % 1000) / 100,
                (time % 100) / 10
        );
    }

    @Contract(pure = true)
    private String formattedDelta(int newTime, int oldTime) {
        final double delta = (double) (newTime - oldTime) / 20;
        return String.format("%+.2f", delta);
    }
}
