package xyz.stachel.zombiesutils.mixin;

import com.llamalad7.mixinextras.injector.ModifyReturnValue;
import com.mojang.authlib.GameProfile;
import net.minecraft.client.network.AbstractClientPlayerEntity;
import net.minecraft.client.network.OtherClientPlayerEntity;
import net.minecraft.client.world.ClientWorld;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import xyz.stachel.zombiesutils.ZombiesUtilsClient;
import xyz.stachel.zombiesutils.config.Configs;

@Mixin(OtherClientPlayerEntity.class)
public abstract class OtherClientPlayerEntityMixin extends AbstractClientPlayerEntity {

    public OtherClientPlayerEntityMixin(ClientWorld world, GameProfile profile) {
        super(world, profile);
    }

    @ModifyReturnValue(method = "shouldRender", at = @At(value = "RETURN"))
    public boolean shouldRender(boolean original, double distance) {
        if (ZombiesUtilsClient.PLAYER_VISIBILITY_SWITCH) {
            double dist = Configs.playerVisibleDistance.getValue();
            double d = this.getBoundingBox().getAverageSideLength() + dist;

            return (distance >= d * d) && original;
        } else {
            return original;
        }
    }
}
